第三次-H-poj-3126-BFS+打表

poj-3126
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

//素数打表
void isprime(void)
{
	int i, j;
	for (i = 1000; i < 10000; i++) 
	{
		for (j = 2; j < i; j++) 
		{
			if (i%j == 0)
			{
				break;
			}
		}
		if (j == i)
		{
			prime[i] = i;
		}
	}
}

题解:题目的意思大概是给出两个四位数的素数,判断第一个素数通过每一次只变换一个数来变成另一个素数,经过多次改变后变成第二个素数,求最小次数。无法变换则输出Impossible

#include<iostream>
#include<cstring>
#include<cstdio>
#include<queue>
#include<cmath>
using namespace std;
#define maxn 10005
struct ans 
{
	int step;//记录步数 
	bool visit;//素数的访问标记
};
ans a[maxn];
int prime[maxn];
//素数打表
void isprime(void)
{
	int i, j;
	for (i = 1000; i < 10000; i++) 
	{
		for (j = 2; j < i; j++) 
		{
			if (i%j == 0)
			{
				break;
			}
		}
		if (j == i)
		{
			prime[i] = i;
		}
	}
}

int bfs(int x, int y)
{
	memset(a, 0, sizeof(a));
	queue<int> H;
	a[x].visit = true;//起始a已访问 
	H.push(x);

	while (!H.empty()) 
	{
		int tem = H.front();
		int t[4];//存储素数的四个数字
		H.pop();
		if (tem == y) //如果找到
		{
			cout << a[y].step << endl;
			return 1;
		}

		t[0] = tem / 1000;//个位
		t[1] = tem % 1000 / 100;//10位
		t[2] = tem % 100 / 10;//百位
		t[3] = tem % 10;//千位
		//改变素数的一位数字入队 
		for (int i = 0; i < 4; i++)
		{
			int k = t[i];//要改的位 
			for (int j = 0; j < 10; j++)
			{
				t[i] = j;//要改的数 
				int temp = t[0] * 1000 + t[1] * 100 + t[2] * 10 + t[3];
				if (temp != tem && !a[temp].visit && prime[temp] != 0)	//与原数不同       未访问过          为素数 
				{
					a[temp].step = a[tem].step + 1;
					a[temp].visit = true;
					H.push(temp);
				}
			}
			t[i] = k;//还原该位; 
		}
	}
	return 0;
}
int main(void) 
{
	int a, b, n;//a,b为两个不同的素数
	isprime();//预处理 

	cin >> n;
	for (int i = 0; i < n; i++) 
	{
		cin >> a >> b;
		if (bfs(a, b) == 0) 
		{
			cout << "Impossible" << endl;
		}
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_43866317/article/details/86662554